import 'package:nyxx/src/nyxx.dart';
import 'package:nyxx/src/core/channel/thread_channel.dart';
import 'package:nyxx/src/typedefs.dart';

abstract class IThreadCreateEvent {
  /// The thread that was just created
  IThreadChannel get thread;
}

/// Fired when a thread is created
class ThreadCreateEvent implements IThreadCreateEvent {
  /// The thread that was just created
  @override
  late final IThreadChannel thread;

  /// Creates an instance of [ThreadCreateEvent]
  ThreadCreateEvent(RawApiMap raw, INyxx client) {
    thread = ThreadChannel(client, raw["d"] as RawApiMap);

    if (client.cacheOptions.channelCachePolicyLocation.event && client.cacheOptions.channelCachePolicy.canCache(thread)) {
      client.channels[thread.id] = thread;
    }
  }
}
